package io.tswf.minecraft.blockventure.recipe.parser

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.expansion.IMetadataSensitiveIngredient
import io.tswf.minecraft.blockventure.recipe.IRecipeIngredientObjectParseProvider
import net.minecraft.item.Item
import net.minecraft.item.ItemStack
import net.minecraft.recipe.Ingredient

@AutoService(IRecipeIngredientObjectParseProvider)
@CompileStatic
class ItemStackIngredientObjectParseProvider implements IRecipeIngredientObjectParseProvider{

    @Override
    Ingredient parseIngredientObject(Object ingredientObject) {
        if (ingredientObject instanceof ItemStack) {
            def ingredient = Ingredient.ofStacks(ingredientObject.copy())
            if (ingredientObject.damage > 0) {
                def metaSensitiveView = (IMetadataSensitiveIngredient) ingredient
                metaSensitiveView.metadataSensitive = true
            }

            return ingredient
        }

        return null
    }
}
